#include <Servo.h>
#include <Stepper.h>
// pin of each components
int Buzzer=13;
int sensor_pin= A3;
int value;
int Led_r = 10;
int Led_g = 11;
int Led_b = 12;
// pin of links between arduino and controller
int DIR = 3;
int STEP = 2;
// numer of steps per revolution
int steps_per_rev = 200;
int pos;
// create a stepper
Stepper myStepper(steps_per_rev,STEP,DIR,4,5);
// In our situation treshold was of 200 but it depends of the environment around the box
int seuil=200;
int time0;


void setup() {
  // set rotation speed of motor
  myStepper.setSpeed(100); 
  // Fix the the amount of data flow between arduino and computer
  Serial.begin(9600);
    //Assign to selected pin OUTPUT mode : this means that they can provide a substantial amount of current to other circuits
  pinMode(Buzzer,OUTPUT);
  pinMode (Led_r, OUTPUT); 
  pinMode (Led_g, OUTPUT);
  pinMode (Led_b, OUTPUT);
  pinMode(DIR, OUTPUT);
}

void loop() {
  // Read the value of light intensity given by photoresistor
  value=analogRead(sensor_pin);
  // Send at computer value measured
  Serial.println(value,DEC);
  // Initialize time origin (millis measure absolute time)
  time0=millis();
  while (value<seuil) {
    // case of light situation
    value=analogRead(sensor_pin);
  Serial.println(value,DEC);
  // 1900 ms is the time necessary for the figurine to go from bottom to top
    if (millis()-time0<1900){
      Serial.println("light");
      // function that command the LED when we are in light situation
      led_montee();
      // move the motor
      myStepper.step(20);
      // Buzzer activation
      digitalWrite(Buzzer,HIGH);
    }
    else {
      Used once the platform is on top
      myStepper.step(0);
    }
}
    time0=millis();
    while (value>=seuil) {
      // Darkness case
      value=analogRead(sensor_pin);
  Serial.println(value,DEC);
  // Considering that the rack can slip when it go down it's faster to go from top to bottom than bottom to top
    if (millis()-time0<1300){
      Serial.println("darkness");
      led_descente();
      myStepper.step(-20);
      digitalWrite(Buzzer,LOW);
    }
    else {
      myStepper.step(0);
    }
  }
}

// Fuction to give to LED a red color
void led_montee() {
  digitalWrite(Led_r,HIGH);
  digitalWrite(Led_g,LOW);
  digitalWrite(Led_b,LOW);
 }

// Fuction to give to LED a green color
void led_descente() {
  digitalWrite(Led_g,HIGH);
  digitalWrite(Led_r,LOW);
  digitalWrite(Led_b,LOW);
}
  
